CREATE OR REPLACE PROCEDURE GERA_PREVCONSVMN(
   P_CDFILIPROC  IN  FILIAL.CDFILIAL%TYPE,
   P_CDFILIAL    IN  FILIAL.CDFILIAL%TYPE,
   P_DTINICVEND  IN  PREVENDAEQU.DTPREVENDEQU%TYPE,
   P_DTFINAVEND  IN  PREVENDAEQU.DTPREVENDEQU%TYPE,
   P_DTINICPREV  IN  PREVENDAEQU.DTPREVENDEQU%TYPE,
   P_DTFINAPREV  IN  PREVENDAEQU.DTPREVENDEQU%TYPE,
   P_CDINICPROD  IN  PRODUTO.CDARVPROD%TYPE DEFAULT NULL,
   P_CDFINAPROD  IN  PRODUTO.CDARVPROD%TYPE DEFAULT NULL)

IS
   V_TPROD      VARCHAR(1);
   V_CDINICPROD PRODUTO.CDPRODUTO%TYPE;
   V_CDFINAPROD PRODUTO.CDPRODUTO%TYPE;

   V_CONT   NUMBER;
   V_VAR01  FLOAT;
   V_VAR02  FLOAT;
   V_VAR03  FLOAT;
   V_VAR04  FLOAT;
   V_VAR05  FLOAT;
   V_VAR06  FLOAT;
   V_VAR07  FLOAT;
   V_VARM   FLOAT;
   V_VARB   FLOAT;

   V_QTPREVENDAEQU FLOAT;
   V_QTPREVENDA    FLOAT;
   V_MEDIA_ARIT    FLOAT;
   V_DEV_PADRAO    FLOAT;
   V_PERC_DESVIO   FLOAT;
   V_QTVENDIDA     FLOAT;
   V_CTPLANOG      NUMBER;
   V_PERPREVMN     FLOAT;
BEGIN
   IF (P_CDINICPROD IS NULL) OR
      (P_CDFINAPROD IS NULL) THEN
      V_TPROD      := 'T';
      V_CDINICPROD := '';
      V_CDFINAPROD := '';
   ELSE
      V_TPROD := '';

      SELECT MIN(CDPRODUTO) INTO V_CDINICPROD
      FROM PRODUTO
      WHERE CDARVPROD = P_CDINICPROD;

      SELECT MAX(CDPRODUTO) INTO V_CDFINAPROD
      FROM PRODUTO
      WHERE CDARVPROD = (SELECT MAX(CDARVPROD)
                         FROM PRODUTO
                         WHERE CDARVPROD LIKE P_CDFINAPROD||'%');

      IF (V_CDINICPROD IS NULL) OR
         (V_CDFINAPROD IS NULL) THEN
         V_TPROD      := 'T';
         V_CDINICPROD := '';
         V_CDFINAPROD := '';
      END IF;
   END IF;

   FOR C_FILI IN (
      SELECT DISTINCT FG.CDFILIAL AS CDFILIALCLIE
      FROM PARFILIALVMN PV, FILGRUPFILI FG
      WHERE PV.CDFILIAL   = P_CDFILIAL
        AND FG.CDGRUPFILI = PV.CDGRUPFILI
      ORDER BY FG.CDFILIAL) LOOP

      /*** APAGA AS PREVISES DO PERDO ***/
      DELETE FROM PREVCONSVMN
      WHERE (CDFILIALCLIE  = C_FILI.CDFILIALCLIE)
        AND (DTPREVENDVMN BETWEEN P_DTINICPREV AND P_DTFINAPREV)
        AND ((CDPRODUTO BETWEEN V_CDINICPROD AND V_CDFINAPROD) OR (V_TPROD = 'T'));

      DELETE FROM PREVENDAVMN
      WHERE (CDFILIALCLIE = C_FILI.CDFILIALCLIE)
        AND (DTPREVENDVMN BETWEEN P_DTINICPREV AND P_DTFINAPREV)
        AND ((CDPRODUTO BETWEEN V_CDINICPROD AND V_CDFINAPROD) OR (V_TPROD = 'T'));

      DELETE FROM PREVENDAEQU
      WHERE (CDFILIALCLIE = C_FILI.CDFILIALCLIE)
        AND (DTPREVENDEQU BETWEEN P_DTINICPREV AND P_DTFINAPREV)
        AND ((CDPRODUTO BETWEEN V_CDINICPROD AND V_CDFINAPROD) OR (V_TPROD = 'T'));

      /*** BUSCA AS VENDAS REALIZADAS NO PERODO ***/
      FOR C_VENDA IN (
         SELECT
            VE.CDFILIALCLIE, VE.CDCLIENTE, MP.CDEQUIPPRO, IT.CDPRODUTO
         FROM
            MAPABASEV MP, ITVENDAVMN IT, VENDAVMN VE
         WHERE (VE.CDFILIALCLIE = C_FILI.CDFILIALCLIE  )
           AND (VE.DTVENDAVMN BETWEEN P_DTINICVEND AND P_DTFINAVEND)
           AND ((IT.CDPRODUTO BETWEEN V_CDINICPROD AND V_CDFINAPROD) OR (V_TPROD = 'T'))
           AND (IT.CDFILIAL     = VE.CDFILIAL      )
           AND (IT.NRVENDA      = VE.NRVENDA       )
           AND (VE.IDSITVENDA  <> '2'              )
           AND (VE.CDFILIAL     = MP.CDFILIAL      )
           AND (VE.NRMAPABASEV  = MP.NRMAPABASEV   )
         GROUP BY VE.CDFILIALCLIE, VE.CDCLIENTE, MP.CDEQUIPPRO, IT.CDPRODUTO
         ORDER BY IT.CDPRODUTO) LOOP

         V_CONT  := 0;
         V_VAR01 := 0;
         V_VAR02 := 0;
         V_VAR03 := 0;
         V_VAR04 := 0;
         FOR C_DATA IN (
            SELECT VE.CDPRODUTO, DT.DTDATA, NVL(VE.VRVENDA, 0) AS VRVENDA
            FROM
               (SELECT IT.CDPRODUTO, VE.DTVENDAVMN, SUM(IT.QTPRODVENDA) AS VRVENDA
                FROM MAPABASEV MP, ITVENDAVMN IT, VENDAVMN VE
                WHERE (VE.CDFILIALCLIE = C_VENDA.CDFILIALCLIE)
                  AND (VE.CDCLIENTE    = C_VENDA.CDCLIENTE)
                  AND (MP.CDEQUIPPRO   = C_VENDA.CDEQUIPPRO)
                  AND (IT.CDFILIAL     = VE.CDFILIAL)
                  AND (IT.NRVENDA      = VE.NRVENDA)
                  AND (IT.CDPRODUTO    = C_VENDA.CDPRODUTO)
                  AND (VE.CDFILIAL     = MP.CDFILIAL)
                  AND (VE.NRMAPABASEV  = MP.NRMAPABASEV)
                GROUP BY IT.CDPRODUTO, VE.DTVENDAVMN) VE,
               (SELECT DTDATA FROM DATA WHERE DTDATA BETWEEN P_DTINICVEND AND P_DTFINAVEND) DT
            WHERE (VE.DTVENDAVMN (+) = DT.DTDATA)
            ORDER BY DT.DTDATA) LOOP

            V_CONT  := V_CONT + 1;
            V_VAR01 := V_VAR01 + (V_CONT * C_DATA.VRVENDA);
            V_VAR02 := V_VAR02 + V_CONT;
            V_VAR03 := V_VAR03 + C_DATA.VRVENDA;
            V_VAR04 := V_VAR04 + (V_CONT * V_CONT);
         END LOOP;
         V_VAR05 := V_VAR02 * V_VAR02;
         V_VAR06 := V_CONT;
         V_VAR07 := V_VAR06 + 1;

         IF ((V_VAR06 * V_VAR04) - V_VAR05) = 0 THEN
            V_VARM := 0;
            V_VARB := 0;
         ELSE
            V_VARM := ((V_VAR06 * V_VAR01) - (V_VAR02 * V_VAR03))/((V_VAR06 * V_VAR04) - V_VAR05);
            V_VARB := ((V_VAR03 * V_VAR04) - (V_VAR02 * V_VAR01))/((V_VAR06 * V_VAR04) - V_VAR05);
         END IF;

         V_QTPREVENDAEQU := (V_VAR07 * V_VARM) + V_VARB;

         SELECT
            AVG(NVL(QTTOTAL,0)),
            ROUND(STDDEV(NVL(QTTOTAL,0)),2),
            SUM(QTTOTAL)
         INTO
            V_MEDIA_ARIT, V_DEV_PADRAO, V_QTVENDIDA
         FROM
            (SELECT DTDATA FROM DATA WHERE DTDATA BETWEEN P_DTINICVEND AND P_DTFINAVEND) DT,
            (SELECT VE.DTVENDAVMN,
               (IT.QTPRODVENDA + NVL(IT.QTFATUVENDA,0) + NVL(IT.QTTESTVENDA,0)) AS QTTOTAL
             FROM MAPABASEV MP, ITVENDAVMN IT, VENDAVMN VE
             WHERE (VE.CDFILIALCLIE = C_VENDA.CDFILIALCLIE)
               AND (VE.CDCLIENTE    = C_VENDA.CDCLIENTE)
               AND (MP.CDEQUIPPRO   = C_VENDA.CDEQUIPPRO)
               AND (VE.DTVENDAVMN BETWEEN P_DTINICVEND AND P_DTFINAVEND)
               AND (IT.CDFILIAL     = VE.CDFILIAL)
               AND (IT.NRVENDA      = VE.NRVENDA)
               AND (IT.CDPRODUTO    = C_VENDA.CDPRODUTO)
               AND (VE.CDFILIAL     = MP.CDFILIAL)
               AND (VE.NRMAPABASEV  = MP.NRMAPABASEV)) VE
         WHERE (DT.DTDATA = VE.DTVENDAVMN (+))
         ORDER BY DT.DTDATA;

         IF V_MEDIA_ARIT = 0 THEN
            V_PERC_DESVIO := 0;
         ELSE
            V_PERC_DESVIO := (ROUND((V_DEV_PADRAO/V_MEDIA_ARIT) * 100, 2));
         END IF;

         FOR C_DT IN (
            SELECT DTDATA FROM DATA
            WHERE DTDATA BETWEEN P_DTINICPREV AND P_DTFINAPREV) LOOP

            SELECT COUNT(*) INTO V_CTPLANOG
            FROM  ITEQUIPPRO IT
            WHERE IT.CDEQUIPPRO   = C_VENDA.CDEQUIPPRO
              AND IT.CDPRODUTO    = C_VENDA.CDPRODUTO
              AND IT.DTINVIGCNFEP = (SELECT MAX(DTINVIGCNFEP) FROM CONFEQUIPPRO
                                     WHERE CDEQUIPPRO    = C_VENDA.CDEQUIPPRO
                                       AND DTINVIGCNFEP <= C_DT.DTDATA);

            IF V_CTPLANOG > 0 THEN
               IF V_QTPREVENDAEQU < 0 THEN
                  V_QTPREVENDA := 0;
               ELSE
                  V_QTPREVENDA := V_QTPREVENDAEQU;
               END IF;

               INSERT INTO PREVENDAEQU
                 (CDFILIALCLIE, CDCLIENTE,    CDEQUIPPRO,   DTPREVENDEQU,  CDPRODUTO,
                  QTPREVENDEQU, QTSOLVENDEQU, VRDESVPADEQU, VRMEDIAEQU,    VRPERPREEQU,
                  CDFILIAL,     IDPRODCNFEQU, QTVENDDIAEQU)
               VALUES
                 (C_VENDA.CDFILIALCLIE,    C_VENDA.CDCLIENTE,    C_VENDA.CDEQUIPPRO,   C_DT.DTDATA,          C_VENDA.CDPRODUTO,
                  NVL(V_QTPREVENDAEQU, 0), NVL(V_QTPREVENDA, 0), NVL(V_DEV_PADRAO, 0), NVL(V_MEDIA_ARIT, 0), NVL(V_PERC_DESVIO, 0),
                  P_CDFILIPROC,            'N',                  NVL(V_QTVENDIDA, 0));
            END IF;
         END LOOP;
      END LOOP;

      /*** INSERE OS PRODUTOS DO PLANOGRAMA DA MQUINA QUE NO POSSUEM PREVISO ***/
      FOR C_DTPLANO IN (
         SELECT DTDATA FROM DATA
         WHERE DTDATA BETWEEN P_DTINICPREV AND P_DTFINAPREV) LOOP

         FOR C_PLANO IN (
            SELECT EQ.CDCLIENTE, EQ.CDEQUIPPRO, IT.CDPRODUTO
            FROM EQUIPAPROD EQ, ITEQUIPPRO IT
            WHERE (EQ.CDFILIAL     = C_FILI.CDFILIALCLIE)
              AND (EQ.CDEQUIPPRO   = IT.CDEQUIPPRO)
              AND (IT.DTINVIGCNFEP = (SELECT MAX(CO.DTINVIGCNFEP)
                                      FROM CONFEQUIPPRO CO
                                      WHERE (CO.CDEQUIPPRO    = EQ.CDEQUIPPRO)
                                        AND (CO.DTINVIGCNFEP <= C_DTPLANO.DTDATA)))
              AND (IT.CDPRODUTO NOT IN (SELECT DISTINCT CDPRODUTO
                                        FROM  PREVENDAEQU
                                        WHERE (CDFILIALCLIE  = C_FILI.CDFILIALCLIE)
                                          AND (CDCLIENTE     = EQ.CDCLIENTE)
                                          AND (CDEQUIPPRO    = EQ.CDEQUIPPRO)
                                          AND (DTPREVENDEQU  = C_DTPLANO.DTDATA)))
            GROUP BY EQ.CDCLIENTE, EQ.CDEQUIPPRO, IT.CDPRODUTO) LOOP

            INSERT INTO PREVENDAEQU
               (CDFILIALCLIE, CDCLIENTE,    CDEQUIPPRO,   DTPREVENDEQU, CDPRODUTO,
                QTPREVENDEQU, QTSOLVENDEQU, VRDESVPADEQU, VRMEDIAEQU,   VRPERPREEQU,
                CDFILIAL,     IDPRODCNFEQU, QTVENDDIAEQU)
            VALUES
               (C_FILI.CDFILIALCLIE, C_PLANO.CDCLIENTE, C_PLANO.CDEQUIPPRO, C_DTPLANO.DTDATA, C_PLANO.CDPRODUTO,
                0, 0, 0, 0, 0,
                P_CDFILIPROC, 'S', 0);
         END LOOP;
      END LOOP;

      /*** PROCEDIMENTO PARA CONSOLIDAR AS PREVISES POR SITE ***/
      FOR C_CONSEQUI IN (
         SELECT PV.CDFILIALCLIE, PV.CDPRODUTO, PV.DTPREVENDEQU,
            SUM(PV.QTPREVENDEQU) AS QTPREVENDEQU,
            SUM(PV.QTSOLVENDEQU) AS QTSOLVENDEQU,
            SUM(PV.VRDESVPADEQU) AS VRDESVPADEQU,
            SUM(PV.VRMEDIAEQU  ) AS VRMEDIAEQU,
            SUM(PV.QTVENDDIAEQU) AS QTVENDIDA
         FROM   PREVENDAEQU PV
         WHERE (PV.CDFILIALCLIE = C_FILI.CDFILIALCLIE)
           AND (PV.DTPREVENDEQU BETWEEN P_DTINICPREV AND P_DTFINAPREV)
           AND ((PV.CDPRODUTO   BETWEEN V_CDINICPROD AND V_CDFINAPROD) OR (V_TPROD = 'T'))
         GROUP BY PV.CDFILIALCLIE, PV.CDPRODUTO, PV.DTPREVENDEQU) LOOP

         IF C_CONSEQUI.VRMEDIAEQU = 0 THEN
            V_PERPREVMN := 0;
         ELSE
            V_PERPREVMN := ((C_CONSEQUI.VRDESVPADEQU/C_CONSEQUI.VRMEDIAEQU) * 100);
         END IF;

         INSERT INTO PREVENDAVMN
            (CDFILIALCLIE,  DTPREVENDVMN,  CDPRODUTO,
             QTPREVENDVMN,  QTSOLVENDVMN,  VRDESVPADVMN,
             VRMEDIAVMN,    VRPERPREVMN,   CDFILIAL,      QTVENDDIAVMN)
         VALUES
            (C_CONSEQUI.CDFILIALCLIE, C_CONSEQUI.DTPREVENDEQU, C_CONSEQUI.CDPRODUTO,
             C_CONSEQUI.QTPREVENDEQU, C_CONSEQUI.QTSOLVENDEQU, C_CONSEQUI.VRDESVPADEQU,
             C_CONSEQUI.VRMEDIAEQU,   V_PERPREVMN,             P_CDFILIPROC,   C_CONSEQUI.QTVENDIDA);

         INSERE_ITEMPREV(C_CONSEQUI.CDFILIALCLIE, '', '', C_CONSEQUI.CDPRODUTO,
                         C_CONSEQUI.QTSOLVENDEQU, 'C', C_CONSEQUI.DTPREVENDEQU);
      END LOOP;
   END LOOP;
END;
/
