/* Sistemas Integrados TECNISA
   Servios

Nome: ATUSALDO_EMPITEM

Descrio:
   Atualiza o saldo do empenho quando o item  excluido ou alterado.
Criao:
31/01/07 - Welbert G. Moitinha */

IF EXISTS (SELECT *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE
              O.NAME = 'ATUSALDO_EMPITEM'
              AND TYPE = 'TR'
              AND U.UID = O.UID
              AND U.NAME = USER)

   DROP TRIGGER ATUSALDO_EMPITEM;
GO

CREATE TRIGGER ATUSALDO_EMPITEM
ON ITEMPEDIDO FOR INSERT, UPDATE, DELETE
AS
   DECLARE @V_IDTABPRECO   VARCHAR(1);
   DECLARE @V_IDUTCTRELANP VARCHAR(1);
   DECLARE @V_IDUTCTREMPEN VARCHAR(1);
   DECLARE @V_NREMPENHO    VARCHAR(20);
   DECLARE @V_CDCLIENTE    VARCHAR(21);
   DECLARE @V_SALDOGERAL   FLOAT;
   DECLARE @V_ID_COMANDO   VARCHAR(1);
   DECLARE @V_CDFILIAL_NEW VARCHAR(4);
   DECLARE @V_NRPEDIDO_NEW VARCHAR(10);
   DECLARE @V_QTITEMPED_NEW    FLOAT;
   DECLARE @V_VRPREUNITPED_NEW FLOAT;
   DECLARE @V_VRDESITPED_NEW   FLOAT;
   DECLARE @V_CDPRODUTO_NEW    VARCHAR(10);
   DECLARE @V_CDFILIAL_OLD     VARCHAR(4);
   DECLARE @V_NRPEDIDO_OLD     VARCHAR(10);
   DECLARE @V_QTITEMPED_OLD    FLOAT;
   DECLARE @V_VRPREUNITPED_OLD FLOAT;
   DECLARE @V_VRDESITPED_OLD   FLOAT;
   DECLARE @V_CDPRODUTO_OLD    VARCHAR(10);
BEGIN
   SET @V_IDTABPRECO   = '';
   SET @V_IDUTCTRELANP = '';
   SET @V_IDUTCTREMPEN = '';
   SET @V_NREMPENHO    = '';
   SET @V_CDCLIENTE    = '';
   SET @V_SALDOGERAL   = 0;

   DECLARE C_CURSOR CURSOR FOR
      SELECT
         'D' IDCOMANDO,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         CDFILIAL,
         NRPEDIDO,
         QTITEMPED,
         VRPREUNITPED,
         VRDESITPED,
         CDPRODUTO
      FROM
         DELETED
      WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)

      UNION ALL

      SELECT
         'U' IDCOMANDO,

         I.CDFILIAL,
         I.NRPEDIDO,
         I.QTITEMPED,
         I.VRPREUNITPED,
         I.VRDESITPED,
         I.CDPRODUTO,
         D.CDFILIAL,
         D.NRPEDIDO,
         D.QTITEMPED,
         D.VRPREUNITPED,
         D.VRDESITPED,
         D.CDPRODUTO
      FROM
         INSERTED I,
         DELETED D
      WHERE
         I.CDFILIAL  = D.CDFILIAL AND
         I.NRPEDIDO  = D.NRPEDIDO AND
         I.NRITEMPED = D.NRITEMPED

      UNION ALL

      SELECT
         'I' IDCOMANDO,

         INSERTED.CDFILIAL,
         INSERTED.NRPEDIDO,
         INSERTED.QTITEMPED,
         INSERTED.VRPREUNITPED,
         INSERTED.VRDESITPED,
         INSERTED.CDPRODUTO,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL
      FROM
         INSERTED
      WHERE
         0 = (SELECT COUNT(*) FROM DELETED)

   OPEN C_CURSOR;

   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_CDFILIAL_NEW,
                                 @V_NRPEDIDO_NEW,
                                 @V_QTITEMPED_NEW,
                                 @V_VRPREUNITPED_NEW,
                                 @V_VRDESITPED_NEW,
                                 @V_CDPRODUTO_NEW,
                                 @V_CDFILIAL_OLD,
                                 @V_NRPEDIDO_OLD,
                                 @V_QTITEMPED_OLD,
                                 @V_VRPREUNITPED_OLD,
                                 @V_VRDESITPED_OLD,
                                 @V_CDPRODUTO_OLD;




   SELECT @V_IDTABPRECO = P.IDTABPRECO,
          @V_IDUTCTRELANP = P.IDUTCTRELANP,
          @V_IDUTCTREMPEN = PR.IDUTCTREMPEN
   FROM PARAMPEDIDO P, PARAMGERAL PR
   WHERE
      P.CDFILIAL =  ISNULL(@V_CDFILIAL_NEW, @V_CDFILIAL_OLD);

   IF(@V_IDTABPRECO = '1')AND(@V_IDUTCTREMPEN = 'S')AND(@V_IDUTCTRELANP in ('1','2'))BEGIN
      WHILE (@@FETCH_STATUS = 0) BEGIN

         SELECT @V_NREMPENHO = P.NREMPENHO, @V_CDCLIENTE = P.CDCLIENTE, @V_SALDOGERAL = E.VRSALDOEMP
         FROM PEDIDO P, EMPENHO E
         WHERE
            P.CDCLIENTE = E.CDCLIENTE AND
            P.NREMPENHO = E.NREMPENHO AND
            ISNULL( @V_CDFILIAL_NEW, @V_CDFILIAL_OLD) = CDFILIAL AND
            ISNULL( @V_NRPEDIDO_NEW, @V_NRPEDIDO_OLD) = NRPEDIDO;

            IF(@V_NREMPENHO >= '0')BEGIN

               IF(@V_ID_COMANDO = 'I')BEGIN
                  IF( @V_SALDOGERAL >= ((@V_QTITEMPED_NEW * @V_VRPREUNITPED_NEW)- ISNULL(@V_VRDESITPED_NEW,0)))BEGIN

                     UPDATE EMPENHO
                     SET VRSALDOEMP = ( VRSALDOEMP - (( @V_QTITEMPED_NEW * @V_VRPREUNITPED_NEW)- ISNULL(@V_VRDESITPED_NEW,0)))
                     WHERE
                        CDCLIENTE = @V_CDCLIENTE AND
                        NREMPENHO = @V_NREMPENHO;
                  END
                  ELSE BEGIN
                     RAISERROR('SALDO_INSU', 16,1);
                  END;
               END
               ELSE BEGIN
                  IF @V_IDUTCTRELANP = '2' BEGIN
                     IF (@V_ID_COMANDO = 'U') BEGIN
                        IF(( @V_CDPRODUTO_NEW IS NOT NULL )AND
                           ( @V_CDPRODUTO_OLD IS NOT NULL )AND
                           ( @V_CDPRODUTO_NEW <> @V_CDPRODUTO_OLD))OR

                          (( @V_QTITEMPED_NEW IS NOT NULL )AND
                           ( @V_QTITEMPED_OLD IS NOT NULL )AND
                           (@V_QTITEMPED_NEW <> @V_QTITEMPED_OLD))OR

                          (( @V_VRPREUNITPED_NEW IS NOT NULL )AND
                           ( @V_VRPREUNITPED_OLD IS NOT NULL )AND
                           ( @V_VRPREUNITPED_NEW <> @V_VRPREUNITPED_OLD))BEGIN

                           SELECT @V_SALDOGERAL = VRSALDOEMP
                           FROM EMPENHO
                           WHERE
                              CDCLIENTE = @V_CDCLIENTE AND
                              NREMPENHO = @V_NREMPENHO;

                           IF( @V_SALDOGERAL >= (( @V_QTITEMPED_NEW * @V_VRPREUNITPED_NEW)- ISNULL( @V_VRDESITPED_NEW,0)))BEGIN
                              UPDATE EMPENHO
                              SET VRSALDOEMP = ( VRSALDOEMP + ((@V_QTITEMPED_OLD * @V_VRPREUNITPED_OLD)- ISNULL(@V_VRDESITPED_OLD,0)))
                              WHERE
                                 CDCLIENTE = @V_CDCLIENTE AND
                                 NREMPENHO = @V_NREMPENHO;

                              UPDATE EMPENHO
                              SET VRSALDOEMP = ( VRSALDOEMP - (( @V_QTITEMPED_NEW * @V_VRPREUNITPED_NEW)- ISNULL( @V_VRDESITPED_NEW,0)))
                              WHERE
                                 CDCLIENTE = @V_CDCLIENTE AND
                                 NREMPENHO = @V_NREMPENHO;

                           END
                           ELSE
                              RAISERROR('SALDO_INSU', 16,1);
                        END;
                     END
                     ELSE BEGIN
                        IF(@V_ID_COMANDO = 'D')BEGIN
                           UPDATE EMPENHO
                           SET VRSALDOEMP = (VRSALDOEMP + (( @V_QTITEMPED_OLD * @V_VRPREUNITPED_OLD)- ISNULL(@V_VRDESITPED_OLD,0)))
                           WHERE
                              CDCLIENTE = @V_CDCLIENTE AND
                              NREMPENHO = @V_NREMPENHO;
                        END;
                     END;
                  END;
               END;
            END;

         FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                       @V_CDFILIAL_NEW,
                                       @V_NRPEDIDO_NEW,
                                       @V_QTITEMPED_NEW,
                                       @V_VRPREUNITPED_NEW,
                                       @V_VRDESITPED_NEW,
                                       @V_CDPRODUTO_NEW,
                                       @V_CDFILIAL_OLD,
                                       @V_NRPEDIDO_OLD,
                                       @V_QTITEMPED_OLD,
                                       @V_VRPREUNITPED_OLD,
                                       @V_VRDESITPED_OLD,
                                       @V_CDPRODUTO_OLD;
      END;
   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO



-- VERSAO --
EXEC ATUVEROBJ 'ATUSALDO_EMPITEM','5.05.015';
GO

